> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create container

> Create a new container with the specified configuration.



## OpenAPI

````yaml /api-reference/services_documented/cloud_api.yaml post /cloud/v1/caas/{project_id}/{region_id}/containers
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Cloud API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-14T07:00:22.640261+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: Bare Metal
    x-displayName: Bare Metal
  - name: Container as a Service
    x-displayName: Container as a Service
  - name: Cost Reports
    x-displayName: Cost Reports
  - name: DDoS Protection
    x-displayName: DDoS Protection
  - name: Everywhere Inference
    x-displayName: Everywhere Inference
  - name: Everywhere Inference Apps
    x-displayName: Everywhere Inference Apps
  - name: File Shares
    x-displayName: File Shares
  - name: Floating IPs
    x-displayName: Floating IPs
  - name: Function as a Service
    x-displayName: Function as a Service
  - name: GPU Bare Metal
    x-displayName: GPU Bare Metal
  - name: GPU Virtual
    x-displayName: GPU Virtual
  - name: IP Ranges
    x-displayName: IP Ranges
  - name: Images
    x-displayName: Images
  - name: Instances
    x-displayName: Instances
  - name: Load Balancers
    x-displayName: Load Balancers
  - name: Logging
    x-displayName: Logging
  - name: Managed Kubernetes
    x-displayName: Managed Kubernetes
  - name: Managed PostgreSQL
    x-displayName: Managed PostgreSQL
  - name: Networks
    x-displayName: Networks
  - name: Placement Groups
    x-displayName: Placement Groups
  - name: Projects
    x-displayName: Projects
  - name: Quotas
    x-displayName: Quotas
  - name: Regions
    x-displayName: Regions
  - name: Registry
    x-displayName: Registry
  - name: Reservations
    x-displayName: Reservations
  - name: Reserved IPs
    x-displayName: Reserved IPs
  - name: Routers
    x-displayName: Routers
  - name: SSH Keys
    x-displayName: SSH Keys
  - name: Secrets
    x-displayName: Secrets
  - name: Security Groups
    x-displayName: Security Groups
  - name: Snapshot Schedules
    x-displayName: Snapshot Schedules
  - name: Snapshots
    x-displayName: Snapshots
  - name: Tasks
    x-displayName: Tasks
  - name: User Actions
    x-displayName: User Actions
  - name: User Role Assignments
    x-displayName: User Role Assignments
  - name: Volumes
    x-displayName: Volumes
paths:
  /cloud/v1/caas/{project_id}/{region_id}/containers:
    post:
      tags:
        - Container as a Service
      summary: Create container
      description: Create a new container with the specified configuration.
      operationId: ContainersHandler.post
      parameters:
        - in: path
          name: project_id
          required: true
          description: Project id
          schema:
            description: Project id
            example: 1
            examples:
              - 1
            title: Project Id
            type: integer
        - in: path
          name: region_id
          required: true
          description: Region id
          schema:
            description: Region id
            example: 1
            examples:
              - 1
            title: Region Id
            type: integer
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ContainerCreateSerializer'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TaskIDsSerializer'
components:
  schemas:
    ContainerCreateSerializer:
      properties:
        commands:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: Container's commands
          examples:
            - python3 app.py -m test
          title: Commands
        description:
          default: ''
          description: Container description
          example: My first container
          examples:
            - My first container
          maxLength: 255
          title: Description
          type: string
        envs:
          description: Container environment variables
          example:
            ENVIRONMENT_VARIABLE: value 2
            ENV_VAR: value 1
          examples:
            - ENVIRONMENT_VARIABLE: value 2
              ENV_VAR: value 1
          patternProperties:
            ^[a-zA-Z_][a-zA-Z0-9_]*$:
              maxLength: 255
              type: string
          propertyNames:
            maxLength: 255
          title: Envs
          type: object
        flavor:
          description: Container flavor
          example: 250mCPU-512MiB
          examples:
            - 250mCPU-512MiB
          pattern: ^[0-9]{0,12}mCPU-[0-9]{0,12}M[i]?B$
          title: Flavor
          type: string
        image:
          description: Container image
          example: nginx:latest
          examples:
            - nginx:latest
          maxLength: 230
          title: Image
          type: string
        is_api_key_auth:
          default: false
          description: >-
            Enable/Disable api key authentication. Enable api key is temporarily
            disabled. As a result, using CaaS with authorization is currently
            not supported.
          example: false
          examples:
            - false
          title: Is Api Key Auth
          type: boolean
        is_disabled:
          default: false
          description: Set to true if container is disabled
          example: false
          examples:
            - false
          title: Is Disabled
          type: boolean
        listening_port:
          description: Container listening port
          example: 80
          examples:
            - 80
          maximum: 65535
          minimum: 1
          title: Listening Port
          type: integer
        logging:
          anyOf:
            - $ref: '#/components/schemas/LoggingSerializer'
            - type: 'null'
          default: null
          description: Logging configuration
          examples:
            - destination_region_id: 1
              enabled: true
              retention_policy:
                period: 45
              topic_name: my-log-name
            - enabled: false
        name:
          description: Container name
          example: nginx
          examples:
            - nginx
          maxLength: 43
          pattern: ^[a-zA-Z0-9][a-zA-Z0-9.-]+[a-zA-Z0-9]$
          title: Name
          type: string
        pull_secret:
          anyOf:
            - maxLength: 400
              type: string
            - type: 'null'
          default: null
          description: Image pull secret
          examples:
            - my-secret
          title: Pull Secret
        scale:
          $ref: '#/components/schemas/ScaleSerializer'
          description: Container autoscaling
          examples:
            - max: 2
              min: 1
        timeout:
          anyOf:
            - maximum: 180
              minimum: 0
              type: integer
            - type: 'null'
          default: null
          description: Container timeout in seconds
          examples:
            - 5
          title: Timeout
      required:
        - name
        - image
        - listening_port
        - flavor
        - scale
      title: ContainerCreateSerializer
      type: object
    TaskIDsSerializer:
      properties:
        tasks:
          description: >-
            List of task IDs representing asynchronous operations. Use these IDs
            to monitor operation progress:

            - `GET /v1/tasks/{task_id}` - Check individual task status and
            details

            Poll task status until completion (`FINISHED`/`ERROR`) before
            proceeding with dependent operations.
          example:
            - d478ae29-dedc-4869-82f0-96104425f565
          examples:
            - - d478ae29-dedc-4869-82f0-96104425f565
          items:
            type: string
          title: Tasks
          type: array
      required:
        - tasks
      title: TaskIDsSerializer
      type: object
    LoggingSerializer:
      properties:
        destination_region_id:
          anyOf:
            - type: integer
            - type: 'null'
          default: null
          description: Destination region id to which the logs will be written
          examples:
            - 1
          title: Destination Region Id
        enabled:
          default: false
          description: Enable/disable forwarding logs to LaaS
          example: true
          examples:
            - true
            - false
          title: Enabled
          type: boolean
        retention_policy:
          anyOf:
            - $ref: '#/components/schemas/LaasIndexRetentionPolicyPydanticSerializer'
            - type: 'null'
          default: null
          description: The logs retention policy
          examples:
            - period: 45
        topic_name:
          anyOf:
            - maxLength: 223
              minLength: 1
              pattern: >-
                ^[a-z0-9](?:[-a-z0-9]*[a-z0-9])?(?:\.[a-z0-9](?:[-a-z0-9]*[a-z0-9])*)*$
              type: string
            - type: 'null'
          default: null
          description: The topic name to which the logs will be written
          examples:
            - my-log-name
          title: Topic Name
      title: LoggingSerializer
      type: object
    ScaleSerializer:
      properties:
        cooldown_period:
          anyOf:
            - maximum: 3600
              minimum: 1
              type: integer
            - type: 'null'
          default: 60
          description: Cooldown period in seconds
          title: Cooldown Period
        max:
          description: Maximum number of instances
          maximum: 25
          minimum: 1
          title: Max
          type: integer
        min:
          description: Minimum number of instances
          maximum: 25
          minimum: 0
          title: Min
          type: integer
        triggers:
          anyOf:
            - $ref: '#/components/schemas/ScaleTriggersSerializer'
            - type: 'null'
          default: null
          description: Scale triggers configuration
      required:
        - min
        - max
      title: ScaleSerializer
      type: object
    LaasIndexRetentionPolicyPydanticSerializer:
      properties:
        period:
          anyOf:
            - exclusiveMinimum: 0
              maximum: 1825
              type: integer
            - type: 'null'
          description: Duration of days for which logs must be kept.
          examples:
            - 45
          title: Period
      required:
        - period
      title: LaasIndexRetentionPolicyPydanticSerializer
      type: object
    ScaleTriggersSerializer:
      properties:
        cpu:
          anyOf:
            - $ref: '#/components/schemas/CpuTriggerSerializer'
            - type: 'null'
          default: null
          description: CPU trigger configuration
        http:
          anyOf:
            - $ref: '#/components/schemas/HttpTriggerSerializer'
            - type: 'null'
          default: null
          description: HTTP trigger configuration
        memory:
          anyOf:
            - $ref: '#/components/schemas/MemoryTriggerSerializer'
            - type: 'null'
          default: null
          description: Memory trigger configuration
      title: ScaleTriggersSerializer
      type: object
    CpuTriggerSerializer:
      properties:
        threshold:
          description: CPU usage percentage
          maximum: 99
          minimum: 1
          title: Threshold
          type: integer
      required:
        - threshold
      title: CpuTriggerSerializer
      type: object
    HttpTriggerSerializer:
      properties:
        rate:
          description: HTTP requests rate
          maximum: 1000
          minimum: 1
          title: Rate
          type: integer
        window:
          description: Time window in seconds
          maximum: 3600
          minimum: 1
          title: Window
          type: integer
      required:
        - rate
        - window
      title: HttpTriggerSerializer
      type: object
    MemoryTriggerSerializer:
      properties:
        threshold:
          description: Memory usage percentage
          maximum: 99
          minimum: 1
          title: Threshold
          type: integer
      required:
        - threshold
      title: MemoryTriggerSerializer
      type: object
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````